#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "types.h"
#include "files.h"
#include "header.h"
#include "esearch.h"
#include "egraphic.h"
#include "blocks.h"
#include "sysdep.h"
#include "key.h"
#include "menu.h"

int gl_ende;

paramtyp params={"reneedit",0,4,70,1,0,1,0,0,1,0,1,1,16000l,4000l,0l};

void window_find (void)
{	int slot,l,y,hl=0,p;
	filetyp *ft;
	menutyp menu[MAXSLOTS],*m=menu;
	char line[2048],*s=line;
	for (slot=0; slot<MAXSLOTS; slot++)
	{	ft=files+slot;
		if (!ft->flags.used) continue;
		l=strlen(ft->name);
		if (l>20)
		{	strcpy(s,"...");
			strcat(s,ft->name+(l-16));
		}
		else strcpy(s,ft->name);
		m->text=s; m->selection=slot;
		m++; s+=strlen(s)+1;
	}
	m->text="--- New ---"; m->selection=MAXSLOTS; m++;
	m->text=0; m->selection=0;
	if (m==menu) return;
	slot=get_top();
	if (slot>=0)
	{	y=files[slot].cursor.y;
		hl=files[slot].hl;
	}
	else y=10;
	l=menu_length(menu);
	if (slot>=0 && y+2+l>=hl) p=hl-l-1;
	else p=y+2;
	if (p==0) p=1;
	slot=select_menu(menu,gl_wchar,p*gl_hchar);
	refresh_top();
	if (topslot==slot) return;
	if (slot<MAXSLOTS)
	{	if (slot<0) return; 
		topslot=slot;
		refresh_top();
	}
	else
	{	load_file();	
	}
	refresh_top();
}			

filetyp *check_ft;
unsigned char check_c1[32],check_c2[32],*check_end,check_stopper;
int check_val1[256],check_val2[256],check_error;
char check_line[256]="[]{}()";

unsigned char *check_for (unsigned char c, unsigned char *start)
{	unsigned char *cx,*cy,*p=start;
	if (check_error) return p;
	while (p<check_end)
	{	if (check_error) return p;
		if (*p==c) { p++; return p; }
		if (check_val1[*p])
		{	cx=check_c1; cy=check_c2;
			while (*cx)
			{	if (*cx++==*p)
				{	p=check_for(*cy,p+1);
					break;
				}
				cy++;
			}
			continue;
		}
		if (check_val2[*p])
		{	if (check_stopper==*p) break;
			form_alert(1,
				"[1][Unexpected closing bracket.][Ok]");
			goto set_pos;
		}
		else p++;
	}
	if (c!=0)
		form_alert(1,"[1][Closing bracket missing.][Ok]");
	else return p;
	p=start-1;
	set_pos:
	check_ft->cursor.line=prev_line((char *)(p+1),check_ft);
	check_ft->cursor.adr=(char *)p;
	check_ft->cursor.x=position(check_ft->cursor.line,check_ft->fend,
		check_ft->tabs,(char *)p);
	fredraw(check_ft-files);
	edit_line(0);
	check_error=1;
	return p;
}

void prepare_check (void)
{	int i;
	unsigned char *p;
	for (i=0; i<256; i++) check_val1[i]=check_val2[i]=0;
	i=0; p=(unsigned char *)check_line;
	while (*p)
	{	check_c1[i]=*p;	check_val1[*p]=1; p++;
		if (*p==0)
		{	form_alert(1,"[1][Not an even number|of brackets!][Abort]");
			return;
		}
		check_c2[i++]=*p; check_val2[*p]=1; p++;
	}
	check_c1[i]=0; check_c2[i]=0;
}

void check_text (void)
{	int slot;
	slot=get_top(); if (slot<0) return; check_ft=files+slot;
	binput("Pairs to check : ",check_line);
	refresh_top();
	prepare_check();
	close_gap(slot);
	check_error=0; check_stopper=0;
	if (block.slot==slot)
	{	check_end=(unsigned char *)block.end;
		check_for(0,(unsigned char *)block.start);
	}
	else
	{	check_end=(unsigned char *)check_ft->fend;
		check_for(0,(unsigned char *)check_ft->start);
	}
}

void find_bracket (void)
{	int slot;
	unsigned char *p,*cx,*cy;
	slot=get_top(); if (slot<0) return; check_ft=files+slot;
	prepare_check();
	close_gap(slot);
	if (check_val1[(int)*(check_ft->cursor.adr)])
	{	cx=check_c1; cy=check_c2;
		while (*cx)
		{	if (*cx==(unsigned char)*(check_ft->cursor.adr))
			{	check_end=(unsigned char *)check_ft->fend;
				check_stopper=*cy; check_error=0;
				p=check_for(*cy,
					(unsigned char *)(check_ft->cursor.adr+1));
				if (!check_error) p--;
				check_ft->cursor.line=
					prev_line((char *)(p+1),check_ft);
				check_ft->cursor.adr=(char *)p;
				check_ft->cursor.x=
					position(check_ft->cursor.line,check_ft->fend,
						check_ft->tabs,(char *)p);
				fredraw(check_ft-files);
				edit_line(0);
				return;
			}
			cx++; cy++;
		}
	}
	else
		form_alert(1,"[1][No Bracket|at cursor position][Ok]");
}	

int isvalid (int c)
{	switch ((unsigned int)c)
	{	case '' :
		case '' :
		case '' :
		case '' :
		case '' :
		case '' :
		case '>' :
		case '<' :
		case '^' :
		case 0x00E1 :
		case 0x009E :
		case '~' :
		case '_' : return 1;
	}
	if (isalnum(c)) return 1;
	if (1<=c && c<=8) return 1;
	return 0;
}

int xstrncmp (char *s1, char *s2, int n)
{	int i;
	for (i=0; i<n; i++)
		if (toupper(*s1++)!=toupper(*s2++))
			return 1;
	return 0;
}

void do_link (void)
{	int slot;
	filetyp *ft;
	char string[64],name[64],alert[256],*s,*p;
	slot=get_top();
	if (slot<0) return; ft=files+slot;
	s=string; p=ft->cursor.adr;
	if (isvalid(*p)) 
	{	while (isvalid(*p) && p>=ft->start) p--;
		p++;
	}
	else
		while (!isvalid(*p) && p<ft->fend) p++;
	if (p>=ft->fend) return;
	while (isvalid(*p) && p<ft->fend && s-string<63) *s++=*p++;
	*s=0;
	switch (string[0])
	{	case 3 : string[0]=4; break;
		case 4 : string[0]=3; break;
		case '>' : string[0]='<'; break;
		case '<' : string[0]='>'; break;
		case 0 : return;
	}
	s=string+1;
	while (*s)
	{	if (*s=='~')
		{	strncpy(name,string+1,s-(string+1));
			name[s-(string+1)]=0;
			for (slot=0; slot<MAXSLOTS; slot++)
				if (files[slot].flags.used)
				{	p=files[slot].name;
					p+=strlen(p);
					while (*p!='\\' && *p!=':' && p>=files[slot].name)
						p--;
					if (!xstrncmp(p+1,name,strlen(name)))
					{	topslot=slot;
						refresh_top();
						break;
					}
				}
			if (slot>=MAXSLOTS)
			{	sprintf(alert,"[1][No file named|%s.][Sorry]",name);
				form_alert(1,alert);
				return;
			}
			strcpy(string+1,s+1);
			break;
		}
		s++;
	}
	make_tab(string,tab);
	ft=files+slot;
	p=ft->cursor.adr+1;
	search(slot,p,ft->fend,string,tab,0,1000,0);
	if (ft->cursor.adr<=p)
		search(slot,ft->start,p,string,tab,0,1000,0);
	strcpy(s_string,string);
	searching=1; s_left=0; s_right=1000; s_cas=0;
}

void show_goto (void)
/* goto line */
{	
	int act;
	char line[64];
	static char gline[256]="";
	act=get_line();
	if (act<0) return;
	sprintf(line,"Now in line %d, goto : ",act);
	binput(line,gline);
	if (gline[0]) act=atoi(gline); else { refresh_top(); return; }
	goto_line(act);
}

void show_cinfo (void)
/* goto info about a charcter */
{	
	int act,slot,c;
	filetyp *ft;
	char output[256];
	slot=topslot;
	if (slot<0) return;
	ft=files+slot;
	act=get_line();
	c=(unsigned char)*(ft->cursor.adr);
	sprintf(output,"[1][%s|Line %d|column %d|ASCII $%x=%d][Ok]",
		ft->name,act,ft->cursor.x+1,c,c);
	form_alert(1,output);
}

void show_cinsert (void)
{	char output[256];
	int c=32;
	sprintf(output,"%d",(unsigned char)c);
	binput("Insert ASCII code : ",output);
	refresh_top();
	c=atoi(output);
	if (!output[0] || c<-255 || c>255) return;
	key_interpret(c);
}

void make_upper (char *s)
{	
	while (*s)
	{	*s=gtoupper(*s);
		s++;
	}
}

int isdez (char a, int *d)
{	
	if (a>='0' && a<='9')
	{	*d=a-'0'; return 1;
	}
	return 0;
}

int ishex (char a, int *d)
{	
	if (a>='0' && a<='9')
	{	*d=a-'0'; return 1;
	}
	if (a>='A' && a<='F')
	{	*d=a-'A'+10; return 1;
	}
	return 0;
}

void extendcpy (char *d, char *s)
/* copy with extension of \x?? */
{	
	int d1,d2,d3;
	while (*s)
	{	if (*s=='\\' && *(s+1)=='x' && *(s+2) && *(s+3) &&
			ishex(*(s+2),&d1) && ishex(*(s+3),&d2))
		{	*d++=d1*16+d2;
			s+=4;
		}
		else if (*s=='\\' && *(s+1)=='d' && *(s+2) && *(s+3) &&
			*(s+4) &&
			ishex(*(s+2),&d1) && ishex(*(s+3),&d2)
				&& isdez(*(s+4),&d3))
		{	*d++=d1*100+d2*10+d3;
			s+=5;
		}
		else
		{	*d++=*s++;
		}
	}
	*d++=0;
}

int scan_number (char **p, int def)
{	int result=0;
	if (!**p || **p<'0' || **p>'9') return def;
	while (**p && **p>='0' && **p<='9')
	{	result=result*10+(**p-'0');
		(*p)++;
	}
	return result;
}

void show_search (void)
{
	static char string[256]="",options[256]="";
	char *p,*start,*end;
	int global=0,blockonly=0;
	if (topslot<0) return;
	binput("Search : ",string);
	if (!string[0]) { refresh_top(); return; }
	extendcpy(s_string,string);
	binput("Options [IBGRnnnLnnn] : ",options);
	s_cas=0; s_left=0; s_right=1000;
	for (p=options; *p; p++)
	{
		switch(*p)
		{	case 'I' :
			case 'i' : s_cas=1; break;
			case 'G' :
			case 'g' : global=1; break;
			case 'B' :
			case 'b' : blockonly=1; break;
			case 'L' :
			case 'l' : p++; s_left=scan_number(&p,0); p--; break;
			case 'R' :
			case 'r' : p++; s_right=scan_number(&p,1000); p--; break;
		}
	}
	if (blockonly && block.slot==topslot)
	{	start=block.start;
		end=block.end;
	}
	else 
	{	end=files[topslot].fend;
		if (global) start=files[topslot].start;
		else
		    start=next_line(files[topslot].cursor.line,
			  files+topslot);
	}
	if (s_cas) make_upper(s_string);
	make_tab(s_string,tab);
	search(topslot,start,end,s_string,tab,s_left,s_right,s_cas);
	searching=1;
}

void show_replace (void)
{	
	static char string[256]="",rstring[256]="",options[256]="";
	char *p,*start,*end;
	int global=0,blockonly=0;
	if (topslot<0) return;
	binput("Search : ",string);
	if (!string[0]) { refresh_top(); return; }
	extendcpy(s_string,string);
	binput("Replace : ",rstring);
	extendcpy(s_repl,rstring);
	binput("Options [IBGARnnnLnnn] : ",options);
	s_cas=0; s_left=0; s_right=1000; s_all=0;
	for (p=options; *p; p++)
	{
		switch(*p)
		{	case 'I' :
			case 'i' : s_cas=1; break;
			case 'G' :
			case 'g' : global=1; break;
			case 'B' :
			case 'b' : blockonly=1; break;
			case 'L' :
			case 'l' : p++; s_left=scan_number(&p,0); p--; break;
			case 'R' :
			case 'r' : p++; s_right=scan_number(&p,1000); p--; break;
			case 'A' :
			case 'a' : s_all=1; break;
		}
	}
	if (blockonly && block.slot==topslot)
	{	start=block.start;
		end=block.end;
	}
	else 
	{	end=files[topslot].fend;
		if (global) start=files[topslot].start;
		else start=next_line(files[topslot].cursor.line,
		       files+topslot);
	}
	if (s_cas) make_upper(s_string);
	make_tab(s_string,tab);
	replace(topslot,start,end,s_string,s_repl,
			tab,s_left,s_right,s_cas,s_all);
	searching=2;
}

void search_again (void)
{
	filetyp *ft;
	char *start,*end;	
	if (topslot<0) return;
	ft=files+topslot;
	if (searching==1)
	{	start=ft->cursor.adr+1;
		end=ft->fend;
		search(topslot,start,end,s_string,tab,s_left,s_right,s_cas);
	}
	else if (searching==2)
	{	start=next_line(ft->cursor.line,ft);
		end=ft->fend;
		replace(topslot,start,end,s_string,s_repl,tab,
			s_left,s_right,s_cas,s_all);
	}		
}

void show_params (void)
/* get params for specific window */
{
	filetyp *ft;
	static char options[256]="";
	char *p;
	if (topslot<0) return;
	ft=files+topslot;
	binput("Local options [I+-W+-B+-K+-TnnnLnnn] : ",options);
	for (p=options; *p; p++)
	{
		switch(*p)
		{	case 'I' :
			case 'i' :
				if (*(p+1)=='-') { p++; ft->flags.indent=0; break; }
				if (*(p+1)=='+') p++;
				ft->flags.indent=1; break;
			case 'W' :
			case 'w' : 
				if (*(p+1)=='-') { p++; ft->flags.wordwrap=0; break; }
				if (*(p+1)=='+') p++;
				ft->flags.wordwrap=1; break;
			case 'B' :
			case 'b' : 
				if (*(p+1)=='-') { p++; ft->flags.blanks=0; break; }
				if (*(p+1)=='+') p++;
				ft->flags.blanks=1; break;
			case 'T' :
			case 't' :
				p++;
				ft->tabs=scan_number(&p,ft->tabs);
				if (ft->tabs>16) ft->tabs=16;
				p--;
				break;
			case 'L' :
			case 'l' :
				p++;
				ft->linelength=scan_number(&p,ft->linelength);
				if (ft->linelength<32) ft->linelength=16;
				p--;
				break;
			case 'K' :
			case 'k' :
				if (*(p+1)=='-') { p++; dotranslate=0; break; }
				if (*(p+1)=='+') p++;
				dotranslate=1; break;
		}
	}
	refresh_top();	
}

int abort_prog (void)
{	int ret;
	ret=form_alert(1,"[2][Abort and forget|all changes?][Ok|No]");
	return ret==1;
}

void load_makros (void);

int main_loop (int argc, char *argv[])
/* Der Ereignisverwalter. Reagiert auf verschiedene Ereignisse */
{	
	XEvent event;
	init_ram();
	load_config();
	get_arguments(argc,argv);
	load_makros();
	do
	{	XNextEvent(display,&event);
			process_event(&event);
	} while (!gl_ende);
	return 0;
}
